# -*- coding: utf-8 -*-
#
# Command for load rss and config
#
# Copyright(C) 2005-, Atzm WATANABE <sitosito@p.chan.ne.jp>
#
# $Id: $

from supercommand import SuperCommand

class command_load(SuperCommand):
	def __init__(self, config):
		"""
		Delete processes are:
			Analyze term:
				1. split command line args (SuperCommand scheduled)
			Load term:
				1. load file
				(2. notice after load term)
		"""
		SuperCommand.__init__(self, config, loadtype=1)
		self.remove_term('modify')
		self.append_term('load', ['load_file'])

	def _load_file(self, c, e, msg, nick, channel):
		try:
			loadtype = self.get_arg('loadtype')
			if  loadtype == 'rss':
				self.load_rss(nick)
			elif loadtype == 'config':
				self.load_config()
			else:
				c.notice(nick, 'Unknown type: %s' % loadtype)
				return False
		except IOError:
			return False
		return True

	def _after_load_term(self, c, e, msg, nick, channel):
		try:    c.notice(nick, 'Reloaded %s file' % self.get_arg('loadtype'))
		except: return False
		return True
