from supermemo  import SuperMemo
from siteparser import SiteParser
from common     import unicoding, htmlspecialchars

class command_tmemo(SuperMemo):
	def __init__(self, config):
		"""
		tmemo processes are:
			Analyze term:
				1. split command line args (SuperCommand scheduled)
				2. get html and extract title
				3. append prefix to title (SuperMemo scheduled)
			Modify term:
				1. load rss for parallel process (SuperCommand scheduled)
				2. add args as item to rss object (SuperMemo scheduled)
			Write term:
				1. write out to rss file (SuperMemo scheduled)
				2. write out to html file (SuperMemo scheduled)
				(3. notice after write term (SuperMemo scheduled) )
		"""
		SuperMemo.__init__(self, config, url=1, description=2)

	def _after_split(self, c, e, msg, nick, channel):
		url = self.get_arg('url')
		try:
			title = self.extract_title(url)
			if not title.strip(): raise
		except:
			#title = url
			c.notice(nick, "Couldn't get title")
			return False
		self.set_arg('title', unicoding(htmlspecialchars(title)))
		return True

	def extract_title(self, url):
		title = SiteParser(url).get_title()
		return title
