#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Common Functions and Variables for IRCMemoBot
#
# Copyright(C) 2005-, Atzm WATANABE <sitosito@p.chan.ne.jp>
#
# $Id: $

import nkf, os, glob, types
import RSS

ns = RSS._NamespaceMap()

PKG = 'IRCMemoBot'
VER = '0.0.7'

IRC_ENCODING = 'iso-2022-jp'

def unicoding(text):
	if type(text) is not types.UnicodeType:
		return unicode(nkf.nkf('-w', text), 'utf-8')
	return text

def ununicoding(text, encoding='utf-8'):
	if type(text) is types.UnicodeType:
		return text.encode(encoding)
	return unicoding(text).encode(encoding)

def expand_path(path):
	return os.path.abspath(os.path.expanduser(path))

def htmlspecialchars(val):
	chars = [
		['<', '&lt;'],
		['>', '&gt;'],
		['"', '&quot;'],
		]
	for old, new in chars:
		val = val.replace(old, new)

	# regex de genkaku ni yatta hou ga ii kanaa?
	val = val.replace('&amp;#', '&#')
	val = val.replace('&amp;%', '&%')
	return val

def get_all_nick(output_rss_path):
	nicknames = []
	for rss_path in glob.glob(os.path.join(os.path.dirname(output_rss_path), '*.rdf')):
		if rss_path == output_rss_path: continue
		nick = os.path.basename(rss_path)[:-4]
		nicknames.append(nick)
	return nicknames
