#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# Logger for IRCMemoBot
#
# Copyright(C) 2005-, Atzm WATANABE <sitosito@p.chan.ne.jp>
#
# $Id: $

import os, fcntl, time
from common import ununicoding

class Logger:
	def __init__(self, config):
		self.config = config

	def write(self, msg, nick, channel):
		logfilename = '%s@%s@%s:%d.log' % (self.config.BOT_NAME, channel,
										   self.config.SERVER_NAME, self.config.SERVER_PORT)
		logfilename = os.path.join(self.config.LOG_DIR, logfilename)

		f = file(logfilename, 'a+')
		fcntl.flock(f.fileno(), fcntl.LOCK_EX)
		f.write('%s <%s> %s\n' % (time.strftime('%Y-%m-%dT%H:%M:%S', time.localtime()),
								  nick, ununicoding(msg)))
		fcntl.flock(f.fileno(), fcntl.LOCK_UN)
		f.close()
