# -*- coding: utf-8 -*-
#
# Plugin to receive remote messages
#
# Copyright(C) 2005-, Atzm WATANABE <sitosito@p.chan.ne.jp>
#
# $Id: $

import socket, thread, os, sys, traceback

ADDR = '/tmp/ircmemobot_plugin_remotemsg.sock'

class plugin_remotemsg:
	def __init__(self, connection, channels):
		self._stopper = True

		self._connection = connection
		self._channels   = channels
		self._socket     = socket.socket(socket.AF_UNIX, socket.SOCK_DGRAM)

		try:
			self._socket.bind(ADDR)
		except socket.error:
			t, v, tb = sys.exc_info()
			try:
				os.remove(ADDR)
			except OSError:
				traceback.print_exception(t, v, tb)
				sys.exit(1)

		self._socket.settimeout(1.0)
		self._fileobj = self._socket.makefile()

		thread.start_new_thread(self.start, ())

	def start(self):
		while self._stopper:
			try:
				msg = self._fileobj.readline().strip()
				self._connection.notice(','.join(self._channels), msg)
			except socket.timeout:
				pass

	def stop(self):
		self._stopper = False
		self._fileobj.close()
		self._socket.close()
		try:
			os.remove(ADDR)
		except OSError:
			pass
